import { Meta } from "./Meta";
import { KeyValue } from "../types";
export declare class GQLElement<BuiltType, NameType = string, MetaType = KeyValue> extends Meta<MetaType> {
    protected _name: NameType & string;
    protected _ref: symbol;
    protected _built: BuiltType;
    protected _description?: string;
    get description(): string;
    get ref(): symbol;
    get name(): NameType & string;
    get built(): BuiltType;
    protected constructor(name?: NameType & string);
    static built<BuiltType = any>(elements: GQLElement<BuiltType>[]): BuiltType[];
    static create(...args: any[]): void;
    setName(name: NameType & string): this;
    setDescription(description: string): this;
    build(): void;
}
